

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.WebKit2WebExtension.Structs.ContextMenuItem_
    ( 

-- * Exported types
    ContextMenuItem_(..)                    ,
    newZeroContextMenuItem_                 ,
    noContextMenuItem_                      ,


 -- * Properties
-- ** Parent
    contextMenuItem_ReadParent              ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.WebKit2WebExtension.Types
import GI.WebKit2WebExtension.Callbacks
import qualified GI.GObject as GObject

newtype ContextMenuItem_ = ContextMenuItem_ (ForeignPtr ContextMenuItem_)
-- | Construct a `ContextMenuItem_` struct initialized to zero.
newZeroContextMenuItem_ :: MonadIO m => m ContextMenuItem_
newZeroContextMenuItem_ = liftIO $ callocBytes 32 >>= wrapPtr ContextMenuItem_

noContextMenuItem_ :: Maybe ContextMenuItem_
noContextMenuItem_ = Nothing

contextMenuItem_ReadParent :: ContextMenuItem_ -> IO GObject.InitiallyUnowned
contextMenuItem_ReadParent s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO (Ptr GObject.InitiallyUnowned)
    val' <- (newObject GObject.InitiallyUnowned) val
    return val'


type family ResolveContextMenuItem_Method (t :: Symbol) (o :: *) :: * where
    ResolveContextMenuItem_Method l o = MethodResolutionFailed l o

instance (info ~ ResolveContextMenuItem_Method t ContextMenuItem_, MethodInfo info ContextMenuItem_ p) => IsLabelProxy t (ContextMenuItem_ -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveContextMenuItem_Method t ContextMenuItem_, MethodInfo info ContextMenuItem_ p) => IsLabel t (ContextMenuItem_ -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


